#! /usr/bin/python
import subprocess
import os
import sys


def restart(gunicorn=""):
    pid = "cat /var/run/gunicorn/" + gunicorn + ".pid"
    if os.system(pid) == 0:
        ppid = subprocess.check_output(pid, shell=True)
        os.system("sudo kill -HUP " + ppid)
        if os.path.exists("/var/run/gunicorn/"+gunicorn+".pid"):
            print "%s restarted successfully" % (gunicorn)
        else:
            print "WARNING cannot find %s after restart" % (gunicorn)
        return
    else:
        start(gunicorn)


def start(gunicorn=""):
    path = "/etc/gunicorn.d/" + gunicorn
    os.system("mkdir /tmp/gunicorn/")
    os.system("cp " + path + " /tmp/gunicorn/.")
    os.system("cd /usr/sbin/ ; \
              sudo ./gunicorn-debian --conf-dir=/tmp/gunicorn/ start")
    os.system("rm -rf /tmp/gunicorn")
    if not(os.path.exists("/var/run/gunicorn/"+gunicorn+".pid")):
        print "%s started successfully" % (gunicorn)
    else:
        print "WARNING looks like %s hasn't started" % (gunicorn)
        return


def stop(gunicorn=""):
    pid = subprocess.check_output(["cat",
                                  "/var/run/gunicorn/"+gunicorn+".pid"])
    os.system("sudo kill " + pid)
    if os.path.exists("/var/run/gunicorn/"+gunicorn+".pid"):
        print "%s stoped successfully" % (gunicorn)
    else:
        print "WARNING cannot stop %s" % (gunicorn)
    return

if __name__ == "__main__":
    if len(sys.argv) != 3:
        print "use: gunicornctl.py restart|start|stop <gunicorn>"
        sys.exit(1)
    if sys.argv[1] == "restart":
        restart(sys.argv[2])
    elif sys.argv[1] == "start":
        start(sys.argv[2])
    elif sys.argv[1] == "stop":
        stop(sys.argv[2])
    else:
        print "use: gunicornctl.py restart|start|stop <gunicorn>"
        sys.exit(1)
